package;

import flash.ui.Mouse;
import org.flixel.FlxButton;
import org.flixel.FlxG;
import org.flixel.FlxGroup;
import org.flixel.FlxPoint;
import org.flixel.FlxSprite;
import org.flixel.FlxState;
import org.flixel.FlxText;
import org.flixel.FlxBasic;
import org.flixel.FlxTilemap;
import org.flixel.FlxObject;
import nme.Assets;

import com.eclecticdesignstudio.motion.Actuate;
import com.eclecticdesignstudio.motion.easing.Elastic;



class BaseLevel extends FlxState
{
	//This is for our messages
	private var topText:FlxText;
	
	//This is our elevator, for smashing the crates
	private var elevator:FlxSprite;

	//overlay
	private var overlay:FlxSprite;
	private var overlayGroup:FlxGroup;
	private var levelInfo:FlxText;

	//basementSprites
	private var robotGroup:FlxGroup;
	private var backGround:FlxSprite;

	//jason sprite
	private var ourPlayer:Player;
	private var roboHead:RobotHead;


	//map
	private var map:FlxTilemap;

	//headgroup
	private var headGroup:FlxGroup;
	private var headCounter:Float;

	//taco
	private var taco:FlxSprite;

	//doors
	private var doorGroup:FlxGroup;

	//buttons
	private var buttonGroup:FlxGroup;




	

	
	public function new()
	{
		
		super();
	}
	
	override public function create():Void
	{
		//Kick the framerate back up
		FlxG.framerate = 40;
		FlxG.flashFramerate = 40;

		robotGroup = new FlxGroup();
		headGroup = new FlxGroup();
		doorGroup = new FlxGroup();
		buttonGroup = new FlxGroup();
		//map = new FlxTilemap();


		

		//add the map
		//setupMap();
		//add(map);
		
		//item stuff
		add(buttonGroup);
		add(doorGroup);

	
		//our mainPlayer
		ourPlayer = new Player(40,320);
		add(ourPlayer);
		robotGroup.add(ourPlayer);


		//head stuff
		headCounter = 0;
		add(headGroup);



		//taco
		taco = new FlxSprite(770,560);
		taco.loadGraphic(FlxAssets.tacoImg,true,false,24,22);
		taco.addAnimation("fader",[0,1,2,3,4,5,4,3,2,1],8);
		//taco.play("fader");
		add(taco);

		//overlay
		overlayGroup = new FlxGroup();

		overlay = new FlxSprite(0,0);
		overlay.makeGraphic(FlxG.width,FlxG.height,0xff000000);
		add(overlay);

		levelInfo = new FlxText(0,FlxG.height*.45,FlxG.width);
		levelInfo.setFont("assets/bithigh");
		levelInfo.setFormat(32,0xffffffff,"center",0xff363636);
		levelInfo.text="LEVEL " + FlxAssets.level;
		add(levelInfo);

		Actuate.update (overlay.setAlpha, 12, [1],[0])
		.ease (Elastic.easeOut);

		Actuate.update (levelInfo.setAlpha, 4, [1],[0])
		.ease (Elastic.easeOut)
		.delay(1);
		//Actuate.tween (overlay, 4, {setAlpha:0} );
		//FlxG.fade(0xff000000,4);
		
				
	


	}

	public function setupMap():Void{

	}
	public function levelComplete():Void{
		taco.kill();
		Actuate.update (overlay.setAlpha, 1.5, [0],[1])
		.ease (Elastic.easeOut)
		.delay(.75)
		.onComplete(nextLevel);

		levelInfo.text = "!!! TACO !!!";
		Actuate.update (levelInfo.setAlpha, 1.25, [0],[1])
		.ease (Elastic.easeOut)
		.onComplete(fadeWin);
		
		levelInfo.size=64;

		Actuate.update (levelInfo.setSize, 2, [24],[48])
		.ease (Elastic.easeOut);

		FlxAssets.level++;
	}

	public function fadeWin():Void{
		FlxG.log("CALLED");
		Actuate.update (levelInfo.setAlpha, 1.75, [1],[0]);
		//.ease (Elastic.easeOut);
		
	}

	public function nextLevel():Void{
		FlxG.switchState(new Level1());
	}
	
	override public function update():Void
	{
		super.update();

		if(ourPlayer.control){

			FlxG.camera.follow(ourPlayer);
		}
		else{
			FlxG.camera.follow(roboHead);
		}
		
		FlxG.camera.setBounds(0,0,800,600);
		FlxG.collide(map,headGroup);
		FlxG.collide(map,ourPlayer);


		//connect head back to body
		if(FlxG.collide(ourPlayer,headGroup)&&headCounter>=1){
				headGroup.clear();
				headCounter=0;
				ourPlayer.getHead();
			
		}

		//check to see if the complete robot hits the taco
		if(FlxG.overlap(ourPlayer,taco)&&!ourPlayer.headless){
			levelComplete();
		}

		//if ourPlayer is headless don't allow reattachment for 1 second
		if(ourPlayer.headless){
			headCounter+=FlxG.elapsed;
		}

		//swap to headless
		if(FlxG.keys.justPressed("X")){
			if(!ourPlayer.headless){
				ourPlayer.loseHead();
				//test robot head
				roboHead = new RobotHead(ourPlayer.x,ourPlayer.y-12);
				robotGroup.add(roboHead);
				headGroup.add(roboHead);
			}
			//swap control
			else{
				FlxG.log(roboHead.control);
				if(roboHead.control){			
					roboHead.control=false;
					ourPlayer.control=true;
					ourPlayer.flicker(.1);
				}
				else{
					roboHead.control=true;
					ourPlayer.control=false;
					roboHead.flicker(.1);
				}
			}//end of swap control


		}

	}


	private function buttonHit(b:Button,r:FlxSprite):Void{
			if(b.touching == FlxObject.UP){
				b.buttonDown();
				openDoors(b.type);
			}
	}

	public function buttonUp(t:Int):Void{
		for (i in 0...doorGroup.length) {
			var d = cast(doorGroup.members[i], Door);
			if(d.type==t&&!d.closed){
				d.closeDoor();
			}
		}
	}

	private function openDoors(type:Int):Void{
		for (i in 0...doorGroup.length) {
			var d = cast(doorGroup.members[i], Door);
			if(d.type==type&&d.closed){
				d.openDoor();
			}
		}
	}//end of openDoors
	
	
	
	//This just quits - state.destroy() is automatically called upon state changing
	private function onQuit():Void 
	{
		FlxG.switchState(new MenuState());
	}
}